//****************************************************************************
//** ui.h extension file, included from the uic-generated form implementation.
//**
//** If you wish to add, delete or rename functions or slots use
//** Qt Designer which will update this file, preserving your code. Create an
//** init() function in place of a constructor, and a destroy() function in
//** place of a destructor.
//*****************************************************************************/

#include <iostream>
	using namespace std;
#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <string.h>
#include <qstring.h>
#include <qmessagebox.h>
#include <qlineedit.h>
#include <qapplication.h>
#include <qsettings.h>

int random_range(int lowest_number, int highest_number)
{
  if(lowest_number > highest_number){
      swap(lowest_number, highest_number);
  }
 
   int range = highest_number - lowest_number + 1;
   static const int dummy = (srand((unsigned)time(0)), 0); //this will only get called once

   double rn = rand();
   int extra = range * (double)rn/(RAND_MAX + 1.0);
   return lowest_number + extra;
}

void letForm::verify()
{
    QSettings scores;
    scores.setPath("corfizz.com",tr("Maths Tester"));
    scores.beginGroup("/Scores");
    int total=scores.readNumEntry("/Scores/total", 0);
    int correct=scores.readNumEntry("/Scores/correct", 0);
    int wrong=scores.readNumEntry("/Scores/wrong", 0);
    int ltotal=scores.readNumEntry("/Scores/ltotal", 0);
    int lcorrect=scores.readNumEntry("/Scores/lcorrect", 0);
    int lwrong=scores.readNumEntry("/Scores/lwrong", 0);
    scores.endGroup();
    if(needToAddToTotal){
	total+=1;
	ltotal+=1;
	needToAddToTotal=false;
    }
    QString currentAnswerWritten = answerBox->text();
    bool ok;
    int currentAnswer = currentAnswerWritten.toInt(&ok);
    answerStatus->show();
    if(currentAnswer == x){
	cout << "Correct" << endl;
	answerStatus->setText(tr("Your answer is correct."));
	if (needToAddToCorrect){
	    correct+=1;
	    lcorrect+=1;
	    needToAddToCorrect=false;
	    needToAddToWrong=false;
	}
    }
    else
    {
	cout << "Wrong" << endl;
	answerStatus->setText(tr("Your answer is currently incorrect."));
	if(needToAddToWrong){
	    wrong+=1;
	    lwrong+=1;
	    needToAddToWrong=false;
	    needToAddToCorrect=false;
	}
    }
    cout << "Saving Scores..." << endl;
    scores.setPath("corfizz.com", tr("Maths Tester"));
    scores.beginGroup("/Scores");
    scores.writeEntry("/Scores/total", total);
    scores.writeEntry("/Scores/correct", correct);
    scores.writeEntry("/Scores/wrong", wrong);
    scores.writeEntry("/Scores/ltotal", ltotal);
    scores.writeEntry("/Scores/lcorrect", lcorrect);
    scores.writeEntry("/Scores/lwrong", lwrong);
    scores.endGroup();
    cout << "Scores Saved" << endl;
    cout << "Score: " << correct << "/" << total << ", so you got " << wrong << " wrong." << endl;
}


void letForm::init()
{
    needToAddToTotal=true;
    needToAddToCorrect=true;
    needToAddToWrong=true;
    QSettings scores;
    scores.setPath("corfizz.com", tr("Maths Tester"));
    scores.beginGroup("/Scores");
    int total=scores.readNumEntry("/Scores/total", 0);
    int correct=scores.readNumEntry("/Scores/correct", 0);
    int wrong=scores.readNumEntry("/Scores/wrong", 0);
    int ltotal=scores.readNumEntry("/Scores/ltotal", 0);
    int lcorrect=scores.readNumEntry("/Scores/lcorrect", 0);
    int lwrong=scores.readNumEntry("/Scores/lwrong", 0);
    scores.endGroup();
    explanation->hide();
    answerStatus->hide();
    
    QSettings settings;
    settings.setPath("corfizz.com", tr("Maths Tester"));
    settings.beginGroup("/Settings");
    int minx = settings.readNumEntry("/Settings/minX", minx);
    int miny = settings.readNumEntry("/Settings/minY", miny);
    int mina = settings.readNumEntry("/Settings/minA", mina);
    int maxx = settings.readNumEntry("/Settings/maxX", maxx);
    int maxy = settings.readNumEntry("/Settings/maxY", maxy);
    int maxa = settings.readNumEntry("/Settings/maxA", maxa);
    bool showexp = settings.readBoolEntry("/Settings/showExp", showexp);
    cout << showexp << endl;
    if(showexp==false){
	expButton->hide();
	adjustSize();
    }
    
    x=random_range(minx,maxx);
    a=random_range(mina,maxa);
    y=random_range(miny,maxy);
    z=(a*x)+y;
    QString aon;
    QString pluson;
    if (a!=1) {
        aon = QString::number(a);
    }
    else
    {
        aon="";
    }
    if (y<1) {
        pluson=" ";
    }
    else
    {
        pluson=" + ";
    }
    QString let = aon + "x" + pluson + QString::number(y) + " = " + QString::number(z);
    cout << (const char*)let << endl;
    equation->setText(let);
    QString currentAnswer;
    currentAnswer = answerBox->displayText();
    cout << currentAnswer << endl;
    settings.endGroup();
}


void letForm::next()
{
    letForm dialog(this);
    dialog.exec();
}



void letForm::generateExplanation()
{
    QString explanationText;
    QString aon;
    if (a!=1) {
        aon = QString::number(a);
    }
    else
    {
        aon="";
    }
    
    if(y>0){
	explanationText=tr("First, subtract ")+QString::number(y)+tr(" from both sides of the equals sign in the equation.\n");
		}
    else if(y<0){
	explanationText=tr("First, add ")+QString::number(-y)+tr(" to both sides of the equals sign in the equation.\n");
		}
    if(y!=0){
	explanationText+=tr("You can also think of 'transferring' ")+QString::number(y)+tr(" to the other side of the equation,\n but changing its sign as you do so.\n")+tr("You now have ")+aon+"x"+" = "+QString::number(z-y)+".\n\n";
}
    if(a!=0 && a!=1){
	explanationText+=tr("Divide both sides by ")+QString::number(a)+tr(" to get x = ")+QString::number(z-y)+"/"+QString::number(a)+tr(" which is ")+QString::number(x)+".\n";
    }
    explanationText+=tr("Therefore x = ")+QString::number(x)+".\n";
    
    explanation->setText(explanationText);
}
