/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include "letForm.h"
#include <qmessagebox.h>
#include <qsettings.h>
#include <iostream>
using namespace std;

void mainMenu::let()
{
    letForm dialog(this);
    dialog.exec();
}

#include "statsdialog.h"

void mainMenu::stats()
{
    QSettings scores;
    scores.setPath("corfizz.com", "Maths Tester");
    scores.beginGroup("/Scores");
    total=scores.readNumEntry("/Scores/total", 0);
    if(total == 0){
	QMessageBox::warning(this, tr("No Statistics"), tr("How do you expect to see statistics when you haven't answered any maths questions yet?"));
    }
    else {
	statsDialog dialog(this);
	dialog.exec();
    }
    scores.endGroup();
}


void mainMenu::aboutMT()
{
    QMessageBox::about(this, tr("About KMathsTest"),
		       tr("<h2>KMathsTest 0.2</h2>"
			  "<p>Copyright &copy; 2004 Justin Morgan, Corfizz Software.</p>"));
}
	

void mainMenu::init()
{
    total=0;
    correct=0;
    wrong=0;
    stotal=0;
    swrong=0;
    scorrect=0;
    ltotal=0;
    lcorrect=0;
    lwrong=0;
    atotal=0;
    acorrect=0;
    awrong=0;
    QSettings scores;
    scores.setPath("corfizz.com", "Maths Tester");
    scores.beginGroup("/Scores");
    total=scores.readNumEntry("/Scores/total", 0);
    int correct=scores.readNumEntry("/Scores/correct", 0);
    int wrong=scores.readNumEntry("/Scores/wrong", 0);
    int stotal=scores.readNumEntry("/Scores/stotal", 0);
    int scorrect=scores.readNumEntry("/Scores/scorrect", 0);
    int swrong=scores.readNumEntry("/Scores/swrong",0);
    int ltotal=scores.readNumEntry("/Scores/ltotal", 0);
    int lcorrect=scores.readNumEntry("/Scores/lcorrect", 0);
    int lwrong=scores.readNumEntry("/Scores/lwrong", 0);
    int atotal=scores.readNumEntry("/Scores/atotal", 0);
    int acorrect=scores.readNumEntry("/Scores/acorrect", 0);
    int awrong=scores.readNumEntry("/Scores/awrong", 0);
   
    scores.endGroup();
    
    int minx = 0;
    int miny = 0;
    int mina = 0;
    int maxx = 0;
    int maxy = 0;
    int maxa = 0;
	    
    int minxs = 0;
    int minys = 0;
    int minas = 0;
    int maxxs = 0;
    int maxys = 0;
    int maxas = 0;
    
    int minia = 0;
    int minib = 0;
    int maxia = 0;
    int maxib = 0;
    bool addop = true;
    bool subop = true;
    bool multop = false;
    bool divop = false;
    
    QSettings settings;
    settings.setPath("corfizz.com", "Maths Tester");
    settings.beginGroup("/Settings");
    showexp = settings.readBoolEntry("/Settings/showExp", showexp);
    
    minx = settings.readNumEntry("/Settings/minX", minx);
    miny = settings.readNumEntry("/Settings/minY", miny);
    mina = settings.readNumEntry("/Settings/minA", mina);
    maxx = settings.readNumEntry("/Settings/maxX", maxx);
    maxy = settings.readNumEntry("/Settings/maxY", maxy);
    maxa = settings.readNumEntry("/Settings/maxA", maxa);
	    
    minxs = settings.readNumEntry("/Settings/minX2", minxs);
    minys = settings.readNumEntry("/Settings/minY2", minys);
    minas = settings.readNumEntry("/Settings/minA2", minas);
    maxxs = settings.readNumEntry("/Settings/maxX2", maxxs);
    maxys = settings.readNumEntry("/Settings/maxY2", maxys);
    maxas = settings.readNumEntry("/Settings/maxA2", maxas);
    
    minia = settings.readNumEntry("/Settings/minia", minia);
    maxia = settings.readNumEntry("/Settings/maxia", maxia);
    minib = settings.readNumEntry("/Settings/minib", minib);
    maxib = settings.readNumEntry("/Settings/maxib", maxib);
    addop = settings.readBoolEntry("/Settings/addop", addop);
    subop = settings.readBoolEntry("/Settings/subop", subop);
    multop = settings.readBoolEntry("/Settings/multop", multop);
    divop = settings.readBoolEntry("/Settings/divop", divop);
    settings.endGroup();
}

#include "optionsform.h"
#include <qapplication.h>

void mainMenu::options()
{
    optionsForm dialog(this);
    dialog.exec();
}

#include "simform.h"

void mainMenu::sim()
{
    simForm dialog(this);
    dialog.exec();
}

#include "arithform.h"

void mainMenu::arith()
{
    arithForm dialog(this);
    dialog.exec();
}
