/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include <qapplication.h>
#include <iostream>
    using namespace std;
#include <algorithm>
#include <cstdlib>
#include "statsdialog.h"

void statsDialog::init()
{
    QSettings scores;
    scores.setPath("corfizz.com", tr("Maths Tester"));
    scores.beginGroup("/Scores");
    int total=scores.readNumEntry("/Scores/total", 0);
    int correct=scores.readNumEntry("/Scores/correct", 0);
    int wrong=scores.readNumEntry("/Scores/wrong", 0);
    int stotal=scores.readNumEntry("/Scores/stotal", 0);
    int scorrect=scores.readNumEntry("/Scores/scorrect", 0);
    int swrong=scores.readNumEntry("/Scores/swrong",0);
    int ltotal=scores.readNumEntry("/Scores/ltotal", 0);
    int lcorrect=scores.readNumEntry("/Scores/lcorrect", 0);
    int lwrong=scores.readNumEntry("/Scores/lwrong", 0);
    int atotal=scores.readNumEntry("/Scores/atotal", 0);
    int acorrect=scores.readNumEntry("/Scores/acorrect", 0);
    int awrong=scores.readNumEntry("/Scores/awrong", 0);
    totalQuestionsVal->setText(QString::number(total));
    correctQuestionsVal->setText(QString::number(correct));
    wrongQuestionsVal->setText(QString::number(wrong));
    totalEquationsVal->setText(QString::number(ltotal));
    correctEquationsVal->setText(QString::number(lcorrect));
    wrongEquationsVal->setText(QString::number(lwrong));
    totalSEquationsVal->setText(QString::number(stotal));
    correctSEquationsVal->setText(QString::number(scorrect));
    wrongSEquationsVal->setText(QString::number(swrong));
    totalArithVal->setText(QString::number(atotal));
    correctArithVal->setText(QString::number(acorrect));
    wrongArithVal->setText(QString::number(awrong));
    progressBar->setTotalSteps(total);
    progressBar->setProgress(0);
    while(progressBar->progress()<correct){
	progressBar->setProgress((progressBar->progress()+1));
    }
    if(total != 0){
	float percent=((float)correct/(float)total)*100;
	cout << (int)percent << endl;
	if(percent==100){
	    commentLabel->setText(tr("100%! Congratulations!"));
	}
	if(percent>49){
	    commentLabel->setText(tr("Keep it up!"));
	}
	if(percent<50){
	    commentLabel->setText(tr("There's room for improvement."));
	}
	if(atotal==awrong && atotal!=0){
	   commentLabel->setText(tr("You need to work on your arithmetic."));
	}
	if(ltotal==lwrong && ltotal!=0){
	   commentLabel->setText(tr("You need to work on linear equations."));
	}
	if(stotal==swrong && stotal!=0){
	   commentLabel->setText(tr("You need to work on simultaneous equations."));
	}
    }
    scores.endGroup();
}

bool statsDialog::maybeResetScores()
{
    int ret = QMessageBox::warning(this, tr("Reset Scores"),
			 tr("If you reset your scores, you will lose the only record of all your hard work.\n"
			    "Do you really want to do this?"),
			 QMessageBox::Yes | QMessageBox::Default,
			 QMessageBox::No,
			 QMessageBox::Cancel | QMessageBox::Escape);
    if (ret == QMessageBox::Yes) {
	resetScores();
    }
    else if (ret == QMessageBox::Cancel) {
	return false;
    }
}

void statsDialog::resetScores()
{
    QSettings scores;
    scores.setPath("corfizz.com", tr("Maths Tester"));
    scores.beginGroup("/Scores");
    int total=scores.readNumEntry("/Scores/total", 0);
    int correct=scores.readNumEntry("/Scores/correct", 0);
    int wrong=scores.readNumEntry("/Scores/wrong", 0);
    int stotal=scores.readNumEntry("/Scores/stotal", 0);
    int scorrect=scores.readNumEntry("/Scores/scorrect", 0);
    int swrong=scores.readNumEntry("/Scores/swrong",0);
    int ltotal=scores.readNumEntry("/Scores/ltotal", 0);
    int lcorrect=scores.readNumEntry("/Scores/lcorrect", 0);
    int lwrong=scores.readNumEntry("/Scores/lwrong", 0);
        int atotal=scores.readNumEntry("/Scores/atotal", 0);
    int acorrect=scores.readNumEntry("/Scores/acorrect", 0);
    int awrong=scores.readNumEntry("/Scores/awrong", 0);
    scores.endGroup();
    total=0;
    correct=0;
    wrong=0;
    stotal=0;
    swrong=0;
    scorrect=0;
    ltotal=0;
    lcorrect=0;
    lwrong=0;
    atotal=0;
    acorrect=0;
    awrong=0;
    scores.setPath("corfizz.com",tr("Maths Tester"));
    scores.beginGroup("/Scores");
    scores.writeEntry("/Scores/total", total);
    scores.writeEntry("/Scores/correct", correct);
    scores.writeEntry("/Scores/wrong", wrong);
    scores.writeEntry("/Scores/ltotal", ltotal);
    scores.writeEntry("/Scores/lcorrect", lcorrect);
    scores.writeEntry("/Scores/lwrong", lwrong);
    scores.writeEntry("/Scores/stotal", stotal);
    scores.writeEntry("/Scores/scorrect", scorrect);
    scores.writeEntry("/Scores/swrong", swrong);
    scores.writeEntry("/Scores/atotal", atotal);
    scores.writeEntry("/Scores/acorrect", acorrect);
    scores.writeEntry("/Scores/awrong", awrong);
    scores.endGroup();
    QMessageBox::information(this, tr("Reset Scores"), tr("Resetting Complete"));
    statsDialog dialog(this);
    dialog.accept();
}
